/**
  * Author solution
  * Task: chips (CodeIT, Season 4, Round 6)
  * Author: Nikola Stoyanov
  */

#include <iostream>
#include <cstdio>

const int MAX_N = 100;

int n;
int mat[2 * MAX_N][MAX_N];  // mat[row][col]

void input ();
void solve ();

int main ()
{
    freopen("chips.in", "r", stdin);
    freopen("chips.out", "w", stdout);

    input();
    solve();

    return 0;
}

void input ()
{
    std::cin >> n;

    for (int row = 0; row < 2 * n; row++)
    {
        for (int col = 0; col < n; col++)
        {
            std::cin >> mat[row][col];
        }
    }
}

void solve ()
{
    // the number of black chips on each board
    int countBlack[2] = {0, 0};

    for (int row = 0; row < n; row++)
    {
        for (int col = 0; col < n; col++)
        {
            // the mirrored row
            int invRow = 2*n - row - 1;

            // check if we have two black chips on mirrored possitions
            if (mat[row][col] && mat[invRow][col])
            {
                printf("-1\n");
                return;
            }

            countBlack[0] += mat[row][col];
            countBlack[1] += mat[invRow][col];
        }
    }

    printf("%d\n", std::min(countBlack[0], countBlack[1]));
}
